'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DomainBuilder = function () {
  (0, _createClass3.default)(DomainBuilder, null, [{
    key: 'extend',
    value: function extend(_ref) {
      var _ref$domain = _ref.domain,
          domain = _ref$domain === undefined ? {} : _ref$domain;

      return new DomainBuilder({ domain: domain });
    }
  }]);

  function DomainBuilder() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        domain = _ref2.domain;

    (0, _classCallCheck3.default)(this, DomainBuilder);

    this._domain = domain;
    this._useCase = false;
    this._config = domain.get('config');
    this._useCases = {};
  }

  (0, _createClass3.default)(DomainBuilder, [{
    key: 'for',
    value: function _for() {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          useCase = _ref3.useCase;

      if (this._useCase) {
        throw new Error('[DomainBuilder#for] An useCase was setting with value ' + this._useCases + '.\n         setup a response with DomainBuilder#respondWith until setup other use case');
      }

      this._useCase = useCase;
      return this;
    }
  }, {
    key: 'respondWith',
    value: function respondWith() {
      var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          success = _ref4.success,
          fail = _ref4.fail;

      if (success !== undefined && fail !== undefined) {
        throw new Error('[DomainBuilder#respondWith] The respond must be success or failer but not both');
      }

      if (success === undefined && fail === undefined) {
        throw new Error('[DomainBuilder#respondWith] success or fail are undefined');
      }

      if (!this._useCase) {
        throw new Error('[DomainBuilder#respondWith] before setting a response must setting a usecase with DomainBuilder#for');
      }

      this._useCases[this._useCase] = { success: success, fail: fail };
      this._useCase = false;

      return this;
    }
  }, {
    key: 'build',
    value: function build() {
      var _this = this;

      var self = this;
      return {
        get: function get(useCase) {
          if (useCase === 'config') {
            return _this._config;
          }
          return self._useCases[useCase] ? {
            execute: function execute(params) {
              var successResponse = self._useCases[useCase]['success'];
              return self._useCases[useCase]['success'] !== undefined ? _promise2.default.resolve(typeof successResponse === 'function' ? successResponse(params) : successResponse) : _promise2.default.reject(self._useCases[useCase]['fail']);
            }
          } : self._domain.get(useCase);
        },
        _map: (0, _assign2.default)(self._domain._map, self._useCases),
        useCases: (0, _assign2.default)(self._domain.useCases || {}, self._useCases)
      };
    }
  }]);
  return DomainBuilder;
}();

exports.default = DomainBuilder;